<?php

if (!defined('FORUM')) die();

$section = isset($_GET['section']) ? $_GET['section'] : null;
$id = isset($_GET['id']) ? intval($_GET['id']) : 0;

if (file_exists($ext_info['path'].'/lang/'.$forum_user['language'].'.php'))
	include $ext_info['path'].'/lang/'.$forum_user['language'].'.php';
else
	include $ext_info['path'].'/lang/English.php';

($hook = get_hook('pan_downloads_mi_new_action_start')) ? eval($hook) : null;

$base_files_path = './../../'.'repository/1_4/extensions/';

if (isset($_POST['add']))
{
	if ($forum_user['pan_downloads_upload'] == '0')
		message('You are a member of a group who is not allowed to add files.');
	
	if (!defined('FORUM_XML_FUNCTIONS_LOADED'))
		require FORUM_ROOT.'include/xml.php';
	
	$content = ($_POST['content'] != '') ? forum_trim($_POST['content']) : '';
	$db_type = forum_trim($_POST['db_type']);
	$source = ($_POST['source'] != '') ? forum_trim($_POST['source']) : '';
	
	$file_size = isset($_FILES['file']['size']) ? $_FILES['file']['size'] : '0';
	$base_file_name = basename($_FILES['file']['name']);
	$file_ext = strtolower(strrchr($base_file_name,'.'));
	
	if ($file_ext != '.zip') 
		$errors[] = 'Unsupported file type '.$file_ext.'. Only ZIP archives.';
	
	$zip = new ZipArchive();
	if ($zip->open($_FILES['file']['tmp_name']) === TRUE) 
	{
		$search_file = $zip->locateName('manifest.xml', ZIPARCHIVE::FL_NODIR);
		if ($search_file == TRUE) 
		{
			$file = $zip->statIndex($search_file);
			if ($file['name'])
			{
				$manifest = $zip->getFromName($file['name']);

				// Make sure we have XML support
				if (!function_exists('xml_parser_create'))
					message('No XML support');
				
				$ext_data = xml_to_array($manifest);
				
				$file_ext_id = $ext_data['extension']['id'];
				$file_ext_title = $ext_data['extension']['title'];
				$file_ext_version = $ext_data['extension']['version'];
				$file_ext_desc = $ext_data['extension']['description'];
				$file_author = $ext_data['extension']['author'];
				$file_min_ver = $ext_data['extension']['minversion'];
				$file_max_ver = $ext_data['extension']['maxtestedon'];
				
				// Make sure we have an array of dependencies
				if (!isset($ext_data['extension']['dependencies']['dependency']))
					$ext_data['extension']['dependencies'] = array();
				else if (!is_array(current($ext_data['extension']['dependencies'])))
					$ext_data['extension']['dependencies'] = array($ext_data['extension']['dependencies']['dependency']);
				else
					$ext_data['extension']['dependencies'] = $ext_data['extension']['dependencies']['dependency'];
				
				$file_dependencies = (!empty($ext_data['extension']['dependencies'])) ? implode(', ', $ext_data['extension']['dependencies']) : '';
				
			}
		}
		$zip->close();
	}
	
	if (isset($file_ext_id) && !empty($file_ext_id))
	{
		$file_link = $base_files_path . $file_ext_id.'/'.$file_ext_id.'.zip';
		
		$query = array(
			'SELECT'	=> 'id, ext_id, ext_ver, poster, poster_id, min_ver, max_ver, db_type, posted, last_update, file_link',
			'FROM'		=> 'pan_downloads',
			'WHERE'		=> 'ext_id=\''.$forum_db->escape($file_ext_id).'\''
		);
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		$file_info = $forum_db->fetch_assoc($result);
		
		if (count($file_info['id']) > 0)
			$errors[] = 'Such an extension already exists.';
		else if (is_dir($base_files_path . $file_ext_id))
			$errors[] = 'This Directory already exists.';
		else if (file_exists($file_link))
			$errors[] = 'This File Archive already exists.';
	}
	
	if (empty($errors))
	{
		if (!mkdir($base_files_path.'/'.$file_ext_id, 0700))
			$errors[] = 'Could not create directory for archive.';
		
		if (move_uploaded_file($_FILES['file']['tmp_name'], $base_files_path . $file_ext_id.'/'.$file_ext_id.'.zip'))
		{
			$fp = fopen($base_files_path . $file_ext_id.'/'.'index.html', 'w');
			fclose($fp);
			
			$query = array(
				'INSERT'	=> 'ext_id, ext_ver, ext_name, ext_desc, content, author, poster, poster_id, min_ver, max_ver, db_type, posted, last_update, file_size, file_link, source, status, dependencies',
				'INTO'		=> 'pan_downloads',
				'VALUES'	=> '
					\''.$forum_db->escape($file_ext_id).'\',
					\''.$forum_db->escape($file_ext_version).'\',
					\''.$forum_db->escape($file_ext_title).'\',
					\''.$forum_db->escape($file_ext_desc).'\',
					\''.$forum_db->escape($content).'\',
					\''.$forum_db->escape($file_author).'\',
					\''.$forum_db->escape($forum_user['username']).'\',
					'.$forum_user['id'].',
					\''.$forum_db->escape($file_min_ver).'\',
					\''.$forum_db->escape($file_max_ver).'\',
					\''.$forum_db->escape($db_type).'\',
					'.time().',
					'.time().',
					\''.$forum_db->escape($file_size).'\',
					\''.$forum_db->escape($file_link).'\',
					\''.$forum_db->escape($source).'\',
					\'public\',
					\''.$forum_db->escape($file_dependencies).'\''
			);
			
			$forum_db->query_build($query) or error(__FILE__, __LINE__);
			$new_id = $forum_db->insert_id();
			
			$forum_flash->add_info('New Extension Uploaded');
			redirect(forum_link($forum_url['pan_downloads_view'], $new_id), '');
		}
		else
		{
			$errors[] = 'Could not upload file.'; }
	}

}
else if (isset($_POST['save']))
{
	if ($forum_user['pan_downloads_edit'] == '0')
		message('You are a member of a group who is not allowed to edit info about files.');
	
	if ($id == 0)
		message('Wrong download id.');
	
	if (!defined('FORUM_XML_FUNCTIONS_LOADED'))
		require FORUM_ROOT.'include/xml.php';
	
	$base_file_name = basename($_FILES['file']['name']);
	$file_ext = strtolower(strrchr($base_file_name,'.'));
	
	$content = forum_trim($_POST['content']);
	$db_type = forum_trim($_POST['db_type']);
	$source = forum_trim($_POST['source']);
	
	if ($file_ext != '.zip') 
		$errors[] = 'Unsupported file type '.$file_ext.'. Only ZIP archives.';
	
	$zip = new ZipArchive();
	if (isset($_FILES['file']['tmp_name']) && ($zip->open($_FILES['file']['tmp_name']) === TRUE))
	{
		$search_file = $zip->locateName('manifest.xml', ZIPARCHIVE::FL_NODIR);
		if ($search_file == TRUE) 
		{
			$file = $zip->statIndex($search_file);
			if ($file['name'])
			{
				$manifest = $zip->getFromName($file['name']);

				// Make sure we have XML support
				if (!function_exists('xml_parser_create'))
					message('No XML support');
				
				$ext_data = xml_to_array($manifest);
				
				$file_ext_id = $ext_data['extension']['id'];
				$file_ext_title = $ext_data['extension']['title'];
				$file_ext_version = $ext_data['extension']['version'];
				$file_ext_desc = $ext_data['extension']['description'];
				$file_author = $ext_data['extension']['author'];
				$file_min_ver = $ext_data['extension']['minversion'];
				$file_max_ver = $ext_data['extension']['maxtestedon'];
				
				// Make sure we have an array of dependencies
				if (!isset($ext_data['extension']['dependencies']['dependency']))
					$ext_data['extension']['dependencies'] = array();
				else if (!is_array(current($ext_data['extension']['dependencies'])))
					$ext_data['extension']['dependencies'] = array($ext_data['extension']['dependencies']['dependency']);
				else
					$ext_data['extension']['dependencies'] = $ext_data['extension']['dependencies']['dependency'];
				
				$file_dependencies = (!empty($ext_data['extension']['dependencies'])) ? implode(', ', $ext_data['extension']['dependencies']) : '';
			}
		}
		$zip->close();
	}
	
	$ext_id = isset($file_ext_id) ? $file_ext_id : forum_trim($_POST['ext_id']);
	
	if (!empty($ext_id))
	{
		$query = array(
			'SELECT'	=> 'id, ext_id, ext_name, ext_ver, ext_desc, author, min_ver, max_ver, poster_id, file_size, dependencies',
			'FROM'		=> 'pan_downloads',
			'WHERE'		=> 'ext_id=\''.$forum_db->escape($ext_id).'\''
		);
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		$file_info = $forum_db->fetch_assoc($result);
		
		if ((count($file_info['id']) > 0) && $file_info['poster_id'] != $forum_user['id'])
			$errors[] = 'Such an extension already exists and is loaded by the developer '.$file_info['poster'];
	}
	
	$ext_ver = (isset($file_ext_version) && ($file_ext_version > $file_info['ext_ver'])) ? $file_ext_version : $file_info['ext_ver'];
	if (isset($file_ext_version) && ($file_ext_version < $file_info['ext_ver']))
		$errors[] = 'The new version of the extension is smaller than the previous version!';
	
	$ext_name = isset($file_ext_title) ? $file_ext_title : $file_info['ext_name'];
	$ext_desc = isset($file_ext_desc) ? $file_ext_desc : $file_info['ext_desc'];
	$author = isset($file_author) ? $file_author : $file_info['author'];
	$min_ver = isset($file_min_ver) ? $file_min_ver : $file_info['min_ver'];
	$max_ver = isset($file_max_ver) ? $file_max_ver : $file_info['max_ver'];
	$dependencies = isset($file_dependencies) ? $file_dependencies : $file_info['dependencies'];
	$file_link = ($_POST['file_link'] != '') ? forum_trim($_POST['file_link']) : $base_files_path . $ext_id.'/'.$ext_id.'.zip';
	$file_size = isset($_FILES['file']['size']) ? intval($_FILES['file']['size']) : $file_info['file_size'];
	
	if (empty($errors))
	{
		if (isset($_FILES['file']['tmp_name']))
			move_uploaded_file($_FILES['file']['tmp_name'], $base_files_path . $ext_id.'/'.$ext_id.'.zip');
		
		$query = array(
			'UPDATE'	=> 'pan_downloads',
			'SET'		=> '
				ext_name=\''.$forum_db->escape($ext_name).'\',
				ext_ver=\''.$forum_db->escape($ext_ver).'\',
				ext_desc=\''.$forum_db->escape($ext_desc).'\',
				content=\''.$forum_db->escape($content).'\',
				author=\''.$forum_db->escape($author).'\',
				min_ver=\''.$forum_db->escape($min_ver).'\',
				max_ver=\''.$forum_db->escape($max_ver).'\',
				db_type=\''.$forum_db->escape($db_type).'\',
				last_update='.time().',
				file_size='.$file_size.',
				file_link=\''.$forum_db->escape($file_link).'\',
				source=\''.$forum_db->escape($source).'\',
				dependencies=\''.$forum_db->escape($dependencies).'\'
				',
			'WHERE'		=> 'id='.$id
		);
		$forum_db->query_build($query) or error(__FILE__, __LINE__);
		
		$forum_flash->add_info('Extension updated.');
//		redirect(forum_link($forum_url['pan_downloads_view'], $id), '');
	}
}
else if (isset($_POST['remove_info']))
{
	$id = intval($_POST['id']);
	$ext_id = forum_trim($_POST['ext_id']);
	if (!empty($ext_id) && $id > 0)
	{
		$query = array(
			'DELETE'	=> 'pan_downloads',
			'WHERE'		=> 'id='.$id
		);
		$forum_db->query_build($query) or error(__FILE__, __LINE__);
		
		$forum_flash->add_info('Extension info deleted from DB.');
	}
	
	redirect(forum_link($forum_url['pan_downloads_list']), '');
}
else if (isset($_POST['remove_full']))
{
	$id = intval($_POST['id']);
	$ext_id = forum_trim($_POST['ext_id']);
	$file_link = $base_files_path.$ext_id.'/'.$ext_id.'.zip';
	
	if (!empty($ext_id) && $id > 0)
	{
		$query = array(
			'DELETE'	=> 'pan_downloads',
			'WHERE'		=> 'id='.$id
		);
		$forum_db->query_build($query) or error(__FILE__, __LINE__);
		
		if (unlink($file_link))
			$forum_flash->add_info('Extension info deleted from DB.');
	}
	
	redirect(forum_link($forum_url['pan_downloads_list']), '');
}
else if (isset($_POST['scan']))
{
	if (!defined('FORUM_XML_FUNCTIONS_LOADED'))
		require FORUM_ROOT.'include/xml.php';
	
	$arr_dirs = array();
	if ($handle = opendir($base_files_path))
	{
		while (false !== ($dirname = readdir($handle)))
		{
			$dirname = $base_files_path.$dirname;
			$tempname = basename($dirname);

			if (is_dir($dirname) && ($tempname != '.') && ($tempname != '..'))
				$arr_dirs[] = $tempname;
		}
		closedir($handle);
	}
	
	foreach ($arr_dirs as $key => $dir_name)
	{
		$file_link = $base_files_path.$dir_name.'/'.$dir_name.'.zip';
		
		if (file_exists($file_link))
		{
			$ext_name = ucwords(str_replace('_', ' ', $dir_name));
			$posted = filectime($file_link);
			$file_size = filesize($file_link);
			
			//Get More Info From Manifest.xml
			if (is_readable($base_files_path . $dir_name.'/'.$dir_name.'/manifest.xml'))
			{
				// Make sure we have XML support
				if (!function_exists('xml_parser_create'))
					message('No XML support');
				
				$manifest = file_get_contents($base_files_path . $dir_name.'/'.$dir_name.'/manifest.xml');
				
				$ext_data = xml_to_array($manifest);
				
				$ext_ver = $ext_data['extension']['version'];
				$ext_desc = $ext_data['extension']['description'];
				$author = $ext_data['extension']['author'];
				$min_ver = $ext_data['extension']['minversion'];
				$max_ver = $ext_data['extension']['maxtestedon'];
				
				// Make sure we have an array of dependencies
				if (!isset($ext_data['extension']['dependencies']['dependency']))
					$ext_data['extension']['dependencies'] = array();
				else if (!is_array(current($ext_data['extension']['dependencies'])))
					$ext_data['extension']['dependencies'] = array($ext_data['extension']['dependencies']['dependency']);
				else
					$ext_data['extension']['dependencies'] = $ext_data['extension']['dependencies']['dependency'];
				
				$dependencies = (!empty($ext_data['extension']['dependencies'])) ? implode(', ', $ext_data['extension']['dependencies']) : '';
			}
			
			
//ext_id, ext_ver, ext_name, ext_desc, content, author, poster, poster_id, min_ver, max_ver, db_type, posted, last_update, file_size, file_link, source, status
			
			$query = array(
				'INSERT'	=> 'ext_id, ext_ver, ext_name, ext_desc, author, poster, poster_id, min_ver, max_ver, posted, last_update, file_size, file_link, status, dependencies',
				'INTO'		=> 'pan_downloads',
				'VALUES'	=> '
					\''.$forum_db->escape($dir_name).'\',
					\''.$forum_db->escape($ext_ver).'\',
					\''.$forum_db->escape($ext_name).'\',
					\''.$forum_db->escape($ext_desc).'\',
					\''.$forum_db->escape($author).'\',
					\''.$forum_db->escape($forum_user['username']).'\',
					'.$forum_user['id'].',
					\''.$forum_db->escape($min_ver).'\',
					\''.$forum_db->escape($max_ver).'\',
					'.$posted.',
					'.$posted.',
					\''.$forum_db->escape($file_size).'\',
					\''.$forum_db->escape($file_link).'\',
					\'public\',
					\''.$forum_db->escape($dependencies).'\''
			);
			$forum_db->query_build($query) or error(__FILE__, __LINE__);
//			$new_id = $forum_db->insert_id();

			$forum_flash->add_info('Scaning done!.');
//			redirect(forum_link($forum_url['pan_downloads_list']), '');
		}
	}
	
//	
}

//
if ($section == 'new')
{
	if ($forum_user['pan_downloads_upload'] == '0')
		message('You are a member of a group who is not allowed to add files.');
	
	// Setup breadcrumbs
	$forum_page['crumbs'] = array(
		array($forum_config['o_board_title'], forum_link($forum_url['index'])),
		array($lang_pan_downloads['downloads'], forum_link($forum_url['pan_downloads_list'])),
		$lang_pan_downloads['crmb_new']
	);

	define('FORUM_PAGE', 'downloads-new');
	require FORUM_ROOT.'header.php';
	
	// START SUBST - <!-- forum_main -->
	ob_start();
?>
	
	<div class="main-head">
		<h2 class="hn"><span>Adding a new download</span></h2>
	</div>
	
	<div class="main-content main-frm">
	
<?php
	// If there were any errors, show them
	if (!empty($errors))
	{
		$forum_page['errors'] = array();
		foreach ($errors as $cur_error)
			$forum_page['errors'][] = '<li class="warn"><span>'.$cur_error.'</span></li>';
?>
		<div class="ct-box error-box">
			<h2 class="warn hn">Correct the following errors</h2>
			<ul class="error-list">
				<?php echo implode("\n\t\t\t\t", $forum_page['errors'])."\n" ?>
			</ul>
		</div>
<?php
	}
?>
		<form id="afocus" class="frm-form frm-ctrl-submit" method="post" accept-charset="utf-8" action="<?php echo forum_link($forum_url['pan_downloads_new']) ?>" enctype="multipart/form-data">
			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_downloads_new'])) ?>" />
			</div>
			
			<fieldset class="frm-group group<?php echo ++$forum_page['group_count'] ?>">
				<legend class="group-legend"><strong></strong></legend>
				
				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
					<div class="sf-box text required">
						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span style="color:red;">Upload form</span><small>Upload the extension in the .ZIP archive</small></label><br />
						<span class="fld-input"><input id="fld<?php echo $forum_page['fld_count'] ?>" name="file" type="file" size="40" /></span>
					</div>
				</div>
				
				<div class="txt-set set<?php echo ++$forum_page['item_count'] ?>">
					<div class="txt-box textarea required">
						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span>Full Description</span></label>
						<div class="txt-input"><span class="fld-input"><textarea id="fld<?php echo $forum_page['fld_count'] ?>" name="content" rows="10" cols="95"><?php echo (isset($_POST['content']) ? forum_htmlencode($content) : '') ?></textarea></span></div>
					</div>
				</div>
				
				<div class="sf-set set">
					<div class="sf-box select">
						<label for="fld">
							<span>Compatibility DB Types</span>
							<small>Select the database on which the extension works.</small>
						</label><br />
						<span class="fld-input">
							<select name="db_type">
								<option value="0">Not tested</option>
								<option value="1">Any DataBase</option>
								<option value="2">Only MySQL</option>
								<option value="3">All except SQLite</option>
							</select>
						</span>
					</div>
				</div>
				
				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
					<div class="sf-box text required longtext">
						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span>Source link</span></label><br />
						<span class="fld-input"><input id="fld<?php echo $forum_page['fld_count'] ?>" type="url" name="source" value="<?php echo isset($_POST['source']) ? forum_htmlencode($_POST['source']) : '' ?>" size="<?php echo FORUM_SUBJECT_MAXIMUM_LENGTH ?>" /></span>
					</div>
				</div>
				
			</fieldset>
			
			<div class="frm-buttons">
				<span class="submit primary"><input type="submit" name="add" value="Add new" /></span>
			</div>
		</form>
		
	</div>
	
<?php

	$tpl_temp = forum_trim(ob_get_contents());
	$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
	ob_end_clean();
	// END SUBST - <!-- forum_main -->
	
	require FORUM_ROOT.'footer.php';
}
else if ($section == 'view' && ($id > 0))
{
	if ($forum_user['pan_downloads'] == '0')
		message('You are a member of a group who is not allowed to download files.');
	
	$query = array(
		'SELECT'	=> 'd.id, d.ext_id, d.ext_ver, d.ext_name, d.ext_desc, d.content, d.author, d.poster, d.poster_id, d.min_ver, d.max_ver, d.db_type, d.posted, d.last_update, d.file_size, d.file_link, d.source, d.downloads, d.views, d.status, d.dependencies, u.email',
		'FROM'		=> 'pan_downloads AS d',
		'JOINS'		=> array(
			array(
				'INNER JOIN'	=> 'users AS u',
				'ON'			=> 'u.id=d.poster_id'
			),
		),
		'WHERE'		=> 'd.id='.$id
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	$downloads_info = $forum_db->fetch_assoc($result);
	
	//
	if (is_readable($base_files_path.$downloads_info['ext_id'].'/'.$downloads_info['ext_id'].'/manifest.xml'))
	{
		if (!defined('FORUM_XML_FUNCTIONS_LOADED'))
			require FORUM_ROOT.'include/xml.php';
		
		// Make sure we have XML support
		if (!function_exists('xml_parser_create'))
			message('No XML support');
		
		$manifest = file_get_contents($base_files_path.$downloads_info['ext_id'].'/'.$downloads_info['ext_id'].'/manifest.xml');
		
		$ext_data = xml_to_array($manifest);
		
		if (empty($downloads_info['ext_ver']))
			$downloads_info['ext_ver'] = $ext_data['extension']['version'];
		
		if (empty($downloads_info['ext_desc']))
			$downloads_info['ext_desc'] = $ext_data['extension']['description'];
		
		if (empty($downloads_info['author']))
			$downloads_info['author'] = $ext_data['extension']['author'];
		
		if (empty($downloads_info['min_ver']))
			$downloads_info['min_ver'] = $ext_data['extension']['minversion'];
		
		if (empty($downloads_info['max_ver']))
			$downloads_info['max_ver'] = $ext_data['extension']['maxtestedon'];
		
		// Make sure we have an array of dependencies
		if (!isset($ext_data['extension']['dependencies']['dependency']))
			$ext_data['extension']['dependencies'] = array();
		else if (!is_array(current($ext_data['extension']['dependencies'])))
			$ext_data['extension']['dependencies'] = array($ext_data['extension']['dependencies']['dependency']);
		else
			$ext_data['extension']['dependencies'] = $ext_data['extension']['dependencies']['dependency'];
		
		if (empty($downloads_info['dependencies']) && !empty($ext_data['extension']['dependencies']))
			$downloads_info['dependencies'] = implode(', ', $ext_data['extension']['dependencies']);
		
	}
	
	
	// Setup breadcrumbs
	$forum_page['crumbs'] = array(
		array($forum_config['o_board_title'], forum_link($forum_url['index'])),
		array($lang_pan_downloads['downloads'], forum_link($forum_url['pan_downloads_list'])),
		$downloads_info['ext_name']
	);

	define('FORUM_PAGE', 'downloads-view');
	require FORUM_ROOT.'header.php';
	
	// START SUBST - <!-- forum_main -->
	ob_start();
	
	($hook = get_hook('pan_downloads_mi_new_action_section_view_ct_set_new')) ? eval($hook) : null;
	
?>

<style>
.data-box{background: #fffef1;}
.ct-legend span{padding-right: .5em;}
.post-byline, .author-info li span strong {font-weight: bold;}
.post-byline {text-decoration: underline;}
.warn-box {max-height: 60px;}
</style>
	
	<div class="main-head">
<?php if ($forum_user['pan_downloads_upload'] == '1') : ?>
			<p class="options"><span><a class="sub-option" href="<?php echo forum_link($forum_url['pan_downloads_new']) ?>" title="Add new downloading.">Add new</a></span></p>
<?php endif; ?>
		<h2 class="hn"><span>Extension ID: <strong><?php echo $downloads_info['ext_id'] ?></strong></span></h2>
	</div>
	
	<div class="main-content main-topic">

		<div class="post odd firstpost topicpost">
			
			<div class="posthead">
				<h3 class="hn post-ident">
					<span class="post-byline">Extension Info</span>
					<span class="post-link"><?php echo format_time($downloads_info['posted']) ?></span>
				</h3>
			</div>
			
			<div class="postbody">
				<div class="post-author">
					<ul class="author-info">
						<div class="userinfo">
							<li><span>Poster: <strong><a title="Go to profile" href="<?php echo forum_link($forum_url['user'], $downloads_info['poster_id']) ?>" target="_blank"><?php echo $downloads_info['poster'] ?></a></strong></span></li>
							<li><span>Author: <strong><?php echo forum_htmlencode($downloads_info['author']) ?></strong></span></li>
							<li><span>Version: <strong><?php echo forum_htmlencode($downloads_info['ext_ver']) ?></strong></span></li>
							<li><span>PunBB Min: <strong><?php echo $downloads_info['min_ver'] ?></strong></span></li>
							<li><span>PunBB Max: <strong><?php echo $downloads_info['max_ver'] ?></strong></span></li>
							<li><span>File size: <strong><?php echo round($downloads_info['file_size']/1024, 1).' Kb' ?></strong></span></li>
							<li><span>Downloads: <strong><?php echo $downloads_info['downloads'] ?></strong></span></li>
							<li><span>Views: <strong><?php echo $downloads_info['views'] ?></strong></span></li>
							<li><span>Last updated: <strong><?php echo format_time($downloads_info['last_update'], 1) ?></strong></span></li>
						</div>
					</ul>
				</div>
				
				<div class="post-entry">
					<h4 class="entry-title hn"><?php echo forum_htmlencode($downloads_info['ext_name']) ?></h4>
					
					<div class="ct-box warn-box">
<?php if (!empty($downloads_info['dependencies'])) : ?>
						<p class="warn">
							<strong>Dependencies: </strong><?php echo $downloads_info['dependencies'] ?>
						</p>
<?php endif; ?>

<?php if (!empty($downloads_info['ext_desc'])) : ?>
						<p class="warn">
							<strong>Description: </strong><?php echo forum_htmlencode($downloads_info['ext_desc']) ?>
						</p>
<?php endif; ?>
						</p>
					</div>
					
					<div class="entry-content">
						<p><?php echo $downloads_info['content'] ?></p>
					</div>
				</div>
			</div>
			
			<div class="postfoot">
				<div class="post-options">
					
					<p class="post-contacts">
						<span class="user-email first-item"><a href="mailto:<?php echo forum_htmlencode($downloads_info['email']) ?>">Email<span>&nbsp;<?php echo forum_htmlencode($downloads_info['poster']) ?></span></a></span>
					</p>
					
					<p class="post-actions">
						<span class="report-post first-item"><a href="<?php echo forum_link($forum_url['pan_downloads_get_file'], $id) ?>">Download</a></span>
<?php if (!empty($downloads_info['source'])) : ?>
						<span class="quote-post"><a href="<?php echo forum_htmlencode($downloads_info['source']) ?>" target="_blank">Discussion</a></span>
<?php endif; ?>
					</p>
				</div>
			</div>
			
		</div>

	</div>
	
	<div class="main-foot">

		<p class="options">
<?php if ($forum_user['pan_downloads_delete'] == '1') : ?>
			<span><a class="mod-option" href="<?php echo forum_link($forum_url['pan_downloads_delete'], $id) ?>">Delete</a></span>
<?php endif; ?>
<?php if ($forum_user['pan_downloads_edit'] == '1') : ?>
			<span><a class="mod-option" href="<?php echo forum_link($forum_url['pan_downloads_edit'], $id) ?>">Edit</a></span>
<?php endif; ?>
<?php if ($forum_user['pan_downloads_upload'] == '1') : ?>
			<span><a class="mod-option" href="<?php echo forum_link($forum_url['pan_downloads_new']) ?>">Add new</a></span>
<?php endif; ?>
		</p>

		<h2 class="hn"><span>Views: <?php echo $downloads_info['views'] ?></span></h2>
	</div>
	
<?php

	$tpl_temp = forum_trim(ob_get_contents());
	$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
	ob_end_clean();
	// END SUBST - <!-- forum_main -->
	
	//Add New View
	$query = array(
		'UPDATE'	=> 'pan_downloads',
		'SET'		=> 'views=views+1',
		'WHERE'		=> 'id='.$id
	);
	$forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	require FORUM_ROOT.'footer.php';
}
else if ($section == 'get_file' && isset($_GET['id']))
{
	if ($forum_user['pan_downloads'] == '0')
		message('You are a member of a group who is not allowed to download files.');
	
	$attach_item = intval($_GET['id']);
	if ($attach_item < 1)
		message($lang_common['Bad request']);

	$query = array(
		'SELECT'	=> 'id, file_link',
		'FROM'		=> 'pan_downloads',
		'WHERE'		=> 'id='.$attach_item
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	$file_info = $forum_db->fetch_assoc($result);
	
	$fp = @fopen($file_info['file_link'], 'rb');

	if (!$fp) {
		message($lang_common['Bad request']);
	}
	else
	{
		$query = array(
			'UPDATE'	=> 'pan_downloads',
			'SET'		=> 'downloads=downloads+1',
			'WHERE'		=> 'id='.$attach_item
		);
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		
		$forum_db->end_transaction();
		$forum_db->close();
		
		header("Cache-Control: no-cache, must-revalidate");
		header('Location: '.$file_info['file_link']);
	}
	
	$forum_db->end_transaction();
	$forum_db->close();
	exit('File not found!');

}
else if ($section == 'edit' && ($id > 0))
{
	if ($forum_user['pan_downloads_edit'] == '0')
		message('You are a member of a group whose users are not allowed to edit the information about the files.');
	
	$query = array(
		'SELECT'	=> 'id, ext_id, ext_ver, ext_name, ext_desc, content, author, poster, poster_id, min_ver, max_ver, db_type, posted, last_update, file_size, file_link, source, downloads, status, dependencies',
		'FROM'		=> 'pan_downloads',
/*		'JOINS'		=> array(
			array(
				'INNER JOIN'	=> 'users AS u',
				'ON'			=> 'u.id=p.poster_id'
			),
		),*/
		'WHERE'		=> 'id='.$id
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	$downloads_info = $forum_db->fetch_assoc($result);
	
	
	
	if (is_readable($base_files_path.$downloads_info['ext_id'].'/'.$downloads_info['ext_id'].'/manifest.xml'))
	{
		if (!defined('FORUM_XML_FUNCTIONS_LOADED'))
			require FORUM_ROOT.'include/xml.php';
		
		// Make sure we have XML support
		if (!function_exists('xml_parser_create'))
			message('No XML support');
		
		$manifest = file_get_contents($base_files_path.$downloads_info['ext_id'].'/'.$downloads_info['ext_id'].'/manifest.xml');
		
		$ext_data = xml_to_array($manifest);
		
//		echo '<pre>';
//		print_r($ext_data);
//		echo '</pre>';
		
		if (empty($downloads_info['ext_ver']))
			$downloads_info['ext_ver'] = $ext_data['extension']['version'];
		
		if (empty($downloads_info['ext_desc']))
			$downloads_info['ext_desc'] = $ext_data['extension']['description'];
		
		if (empty($downloads_info['author']))
			$downloads_info['author'] = $ext_data['extension']['author'];
		
		if (empty($downloads_info['min_ver']))
			$downloads_info['min_ver'] = $ext_data['extension']['minversion'];
		
		if (empty($downloads_info['max_ver']))
			$downloads_info['max_ver'] = $ext_data['extension']['maxtestedon'];
			
		// Make sure we have an array of dependencies
		if (!isset($ext_data['extension']['dependencies']['dependency']))
			$ext_data['extension']['dependencies'] = array();
		else if (!is_array(current($ext_data['extension']['dependencies'])))
			$ext_data['extension']['dependencies'] = array($ext_data['extension']['dependencies']['dependency']);
		else
			$ext_data['extension']['dependencies'] = $ext_data['extension']['dependencies']['dependency'];
		
		if (empty($downloads_info['dependencies']) && !empty($ext_data['extension']['dependencies']))
			$downloads_info['dependencies'] = implode(',', $ext_data['extension']['dependencies']);
			
	}
	
	
	
	// Setup breadcrumbs
	$forum_page['crumbs'] = array(
		array($forum_config['o_board_title'], forum_link($forum_url['index'])),
		array($lang_pan_downloads['downloads'], forum_link($forum_url['pan_downloads_list'])),
		'Editor: '.$downloads_info['ext_name']
	);

	define('FORUM_PAGE', 'downloads-edit');
	require FORUM_ROOT.'header.php';
	
	// START SUBST - <!-- forum_main -->
	ob_start();
?>
	
	<div class="main-head">
		<h2 class="hn"><span>Adding a new download</span></h2>
	</div>
	
	<div class="main-content main-frm">
	
<?php
	// If there were any errors, show them
	if (!empty($errors))
	{
		$forum_page['errors'] = array();
		foreach ($errors as $cur_error)
			$forum_page['errors'][] = '<li class="warn"><span>'.$cur_error.'</span></li>';
?>
		<div class="ct-box error-box">
			<h2 class="warn hn">Correct the following errors</h2>
			<ul class="error-list">
				<?php echo implode("\n\t\t\t\t", $forum_page['errors'])."\n" ?>
			</ul>
		</div>
<?php
	}
?>

		<form id="afocus" class="frm-form frm-ctrl-submit" method="post" accept-charset="utf-8" action="<?php echo forum_link($forum_url['pan_downloads_edit'], $id) ?>" enctype="multipart/form-data">
			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_downloads_edit'], $id)) ?>" />
				
				<input type="hidden" name="id" value="<?php echo $downloads_info['id'] ?>" />
				<input type="hidden" name="ext_id" value="<?php echo $downloads_info['ext_id'] ?>" />
				<input type="hidden" name="file_size" value="<?php echo $downloads_info['file_size'] ?>" />
				<input type="hidden" name="file_link" value="<?php echo $downloads_info['file_link'] ?>" />
			</div>
			
			<fieldset class="frm-group group<?php echo ++$forum_page['group_count'] ?>">
				<legend class="group-legend"><strong></strong></legend>
				
				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
					<div class="sf-box text required">
						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span>Upload form</span><small>Just download the new extension, and the old one will be deleted. Only .ZIP Archives</small></label><br />
						<span class="fld-input"><input id="fld<?php echo $forum_page['fld_count'] ?>" name="file" type="file" size="40" /></span>
					</div>
				</div>
				
				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
					<div class="sf-box text required longtext">
						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span>Version</span></label><br />
						<span class="fld-input"><input id="fld<?php echo $forum_page['fld_count'] ?>" type="text" name="ext_ver" value="<?php echo isset($_POST['ext_ver']) ? forum_htmlencode($_POST['ext_ver']) : $downloads_info['ext_ver'] ?>" size="35" /></span>
					</div>
				</div>
				
				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
					<div class="sf-box text required longtext">
						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span>Developer</span></label><br />
						<span class="fld-input"><input id="fld<?php echo $forum_page['fld_count'] ?>" type="text" name="author" value="<?php echo isset($_POST['author']) ? forum_htmlencode($_POST['author']) : $downloads_info['author'] ?>" size="35" /></span>
					</div>
				</div>
				
				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
					<div class="sf-box text required longtext">
						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span>Extension Name</span></label><br />
						<span class="fld-input"><input id="fld<?php echo $forum_page['fld_count'] ?>" type="text" name="ext_name" value="<?php echo isset($_POST['ext_name']) ? forum_htmlencode($_POST['ext_name']) : $downloads_info['ext_name'] ?>" size="<?php echo FORUM_SUBJECT_MAXIMUM_LENGTH ?>" /></span>
					</div>
				</div>
				
				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
					<div class="sf-box text required longtext">
						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span>Dependencies</span><small>Write down all dependencies separated by commas.</small></label><br />
						<span class="fld-input"><input id="fld<?php echo $forum_page['fld_count'] ?>" type="text" name="dependencies" value="<?php echo isset($_POST['dependencies']) ? forum_htmlencode($_POST['dependencies']) : $downloads_info['dependencies'] ?>" size="<?php echo FORUM_SUBJECT_MAXIMUM_LENGTH ?>" /></span>
					</div>
				</div>
				
				<div class="txt-set set<?php echo ++$forum_page['item_count'] ?>">
					<div class="txt-box textarea required">
						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span>Short Description</span></label>
						<div class="txt-input"><span class="fld-input"><textarea id="fld<?php echo $forum_page['fld_count'] ?>" name="ext_desc" rows="3" cols="95"><?php echo isset($_POST['ext_desc']) ? forum_htmlencode($_POST['ext_desc']) : $downloads_info['ext_desc'] ?></textarea></span></div>
					</div>
				</div>
				
				<div class="txt-set set<?php echo ++$forum_page['item_count'] ?>">
					<div class="txt-box textarea required">
						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span>Full Description</span></label>
						<div class="txt-input"><span class="fld-input"><textarea id="fld<?php echo $forum_page['fld_count'] ?>" name="content" rows="10" cols="95"><?php echo isset($_POST['content']) ? forum_htmlencode($_POST['content']) : $downloads_info['content'] ?></textarea></span></div>
					</div>
				</div>
<?php
	$all_punbb_versions = array(
		'1.3.6',
		'1.4',
		'1.4.2',
		'1.4.4'
	);
?>
				<div class="sf-set set">
					<div class="sf-box select">
						<label for="fld"><span>Min Version</span></label><br />
						<span class="fld-input">
							<select name="min_ver">
<?php
	$cur_min_ver = isset($_POST['min_ver']) ? $_POST['min_ver'] : $downloads_info['min_ver'];
	foreach ($all_punbb_versions as $punbb_min_version)
	{
		if ($punbb_min_version == $cur_min_ver)
			echo '<option value="'.$punbb_min_version.'" selected="selected">'.$punbb_min_version.'</option>';
		else
			echo '<option value="'.$punbb_min_version.'">'.$punbb_min_version.'</option>';
	}
?>
							</select>
						</span>
					</div>
				</div>
				
				<div class="sf-set set">
					<div class="sf-box select">
						<label for="fld"><span>Max Version</span></label><br />
						<span class="fld-input">
							<select name="max_ver">
<?php
	$cur_max_ver = isset($_POST['max_ver']) ? $_POST['max_ver'] : $downloads_info['max_ver'];
	foreach ($all_punbb_versions as $punbb_max_version)
	{
		if ($punbb_max_version == $cur_max_ver)
			echo '<option value="'.$punbb_max_version.'" selected="selected">'.$punbb_max_version.'</option>';
		else
			echo '<option value="'.$punbb_max_version.'">'.$punbb_max_version.'</option>';
	}
?>
							</select>
						</span>
					</div>
				</div>
<?php
	$all_db_types = array(
		'0'		=> 'Not tested',
		'1'		=> 'Any DataBase',
		'2'		=> 'Only MySQL',
		'3'		=> 'All except SQLite',
	);
?>
				<div class="sf-set set">
					<div class="sf-box select">
						<label for="fld">
							<span>Compatibility DB Types</span>
							<small>Select the database on which the extension works.</small>
						</label><br />
						<span class="fld-input">
							<select name="db_type">
<?php
	$cur_db_type = isset($_POST['db_type']) ? $_POST['db_type'] : $downloads_info['db_type'];
	foreach ($all_db_types as $key => $punbb_db_type)
	{
		if ($key == $cur_db_type)
			echo '<option value="'.$key.'" selected="selected">'.$punbb_db_type.'</option>';
		else
			echo '<option value="'.$key.'">'.$punbb_db_type.'</option>';
	}
?>
							</select>
						</span>
					</div>
				</div>
				
				<input type="hidden" name="file_link" value="<?php echo $downloads_info['file_link'] ?>" />
				
				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
					<div class="sf-box text required longtext">
						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span>Source</span></label><br />
						<span class="fld-input"><input id="fld<?php echo $forum_page['fld_count'] ?>" type="url" name="source" value="<?php echo isset($_POST['source']) ? forum_htmlencode($_POST['source']) : $downloads_info['source'] ?>" size="<?php echo FORUM_SUBJECT_MAXIMUM_LENGTH ?>" /></span>
					</div>
				</div>
				
			</fieldset>
			
			<div class="frm-buttons">
				<span class="submit primary"><input type="submit" name="save" value="Update" /></span>
			</div>
		</form>
		
	</div>
	
<?php

	$tpl_temp = forum_trim(ob_get_contents());
	$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
	ob_end_clean();
	// END SUBST - <!-- forum_main -->
	
	require FORUM_ROOT.'footer.php';
}
else if ($section == 'delete' && ($id > 0) && ($forum_user['g_id'] == FORUM_ADMIN))
{
	$query = array(
		'SELECT'	=> 'id, ext_id, ext_name, ext_desc',
		'FROM'		=> 'pan_downloads',
		'WHERE'		=> 'id='.$id
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	$downloads_info = $forum_db->fetch_assoc($result);
	
	// Setup breadcrumbs
	$forum_page['crumbs'] = array(
		array($forum_config['o_board_title'], forum_link($forum_url['index'])),
		array($lang_pan_downloads['downloads'], forum_link($forum_url['pan_downloads_list'])),
		'Delete file: '.$downloads_info['ext_name']
	);

	define('FORUM_PAGE', 'downloads-delete');
	require FORUM_ROOT.'header.php';
	
	// START SUBST - <!-- forum_main -->
	ob_start();
?>
	
	<div class="main-head">
		<h2 class="hn"><span>Delete file</span></h2>
	</div>
	
	<div class="main-content main-frm">
		
		<div class="ct-box info-box">
			<p class="warn">
			<strong>Warning! </strong>What do you want to do with the file <?php echo $downloads_info['ext_name'] ?>? </p>
		</div>
		
		<form id="afocus" class="frm-form frm-ctrl-submit" method="post" accept-charset="utf-8" action="<?php echo forum_link($forum_url['pan_downloads_list']) ?>">
			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_downloads_list'])) ?>" />
				<input type="hidden" name="id" value="<?php echo $downloads_info['id'] ?>" />
				<input type="hidden" name="ext_id" value="<?php echo $downloads_info['ext_id'] ?>" />
			</div>
						<div class="frm-buttons">
				<span class="cancel">
					<input type="submit" name="remove_info" value="Delete info">
				</span>
				<span class="submit">
					<input type="submit" name="remove_full" value="Full deleting">
				</span>
			</div>
		</form>
		
	</div>
	
<?php

	$tpl_temp = forum_trim(ob_get_contents());
	$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
	ob_end_clean();
	// END SUBST - <!-- forum_main -->
	
	require FORUM_ROOT.'footer.php';
}
else
{
	if ($forum_user['pan_downloads'] == '0')
		message('You are a member of a group who is not allowed to download files.');
	
	$query = array(
		'SELECT'	=> 'id, ext_id, ext_ver, ext_name, ext_desc, file_size, file_link, source, downloads',
		'FROM'		=> 'pan_downloads',
		'ORDER BY'	=> 'ext_id',
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	$downloads_info = array();
	while ($rows = $forum_db->fetch_assoc($result))
		$downloads_info[] = $rows;
	
	// Setup breadcrumbs
	$forum_page['crumbs'] = array(
		array($forum_config['o_board_title'], forum_link($forum_url['index'])),
		$lang_pan_downloads['downloads']
	);

	define('FORUM_PAGE', 'downloads-list');
	require FORUM_ROOT.'header.php';
	
	// START SUBST - <!-- forum_main -->
	ob_start();

	if (count($downloads_info) > 0)
	{
?>
<style>
h3 span.head{font-weight: bold;font-style: normal;color: #00579C;}
.data-box {background-color: #F4F9FD;}
.ct-box div{padding:0;}
.ext-foot .options{float: left !important;}
.ext-foot .post-actions{text-align: right;float: right;}
.ext-foot .options span{margin-right: .75em;}
.ext-foot .post-actions span{margin-left: .75em;}
</style>

		<div class="main-head">
<?php if ($forum_user['pan_downloads_upload'] == '1') : ?>
			<p class="options"><span><a class="sub-option" href="<?php echo forum_link($forum_url['pan_downloads_new']) ?>" title="Add new downloading.">Add new</a></span></p>
<?php endif; ?>
			<h2 class="hn"><span>PunBB Extensions</span></h2>
		</div>
		
		<div class="main-content main-frm">
			
			<div class="ct-box info-box">
				<p>If you are not familiar with the PunBB.INFO extensions, we strongly recommend that you read the annotation for each extension. Do not download and install them all in a row. Use only those that you really need.</p>
			</div>
<?php
		foreach ($downloads_info as $key => $down_info)
		{
?>
			<div class="ct-box data-box">
				<h2 class="hn"><strong><?php echo $down_info['ext_id'] ?></strong> v.<?php echo $down_info['ext_ver'] ?></h2>
				<h3><span class="head"><a title="More information about this product" href="<?php echo forum_link($forum_url['pan_downloads_view'], $down_info['id']) ?>"><?php echo $down_info['ext_name'] ?></a></span></h3>
				<p><?php echo $down_info['ext_desc'] ?></p>
				
				<div class="ext-foot">
					<p class="options">
						<span class="first-item"><a href="<?php echo forum_link($forum_url['pan_downloads_get_file'], $down_info['id']) ?>" title="Download archive in ZIP format">Download .Zip (<?php echo round($down_info['file_size']/1024, 1).' Kb' ?>)</a></span> 
<?php if (!empty($down_info['source'])) : ?>
						<span><a href="<?php echo $down_info['source'] ?>" title="Discuss on the forum">Discuss</a></span>
<?php endif; ?>
						<span title="Number of downloads">Downloaded (<?php echo $down_info['downloads'] ?>)</span> 
					</p>

					<p class="post-actions">
<?php if ($forum_user['pan_downloads_upload'] == '1') : ?>
						<span class="quote-post first-item"><a href="<?php echo forum_link($forum_url['pan_downloads_new']) ?>">Add new</a></span>
<?php endif; ?>
						
<?php if ($forum_user['pan_downloads_edit'] == '1') : ?>
						<span class="edit-post"><a href="<?php echo forum_link($forum_url['pan_downloads_edit'], $down_info['id']) ?>">Edit</a></span>
<?php endif; ?>

<?php if ($forum_user['pan_downloads_delete'] == '1') : ?>
						<span class="delete-topic"><a href="<?php echo forum_link($forum_url['pan_downloads_delete'], $down_info['id']) ?>">Delete</a></span>
<?php endif; ?>
					</p>

				</div>
				
			</div>
<?php
		}
?>
		</div>
<?php
	}
	else
	{
?>
		<div class="main-head">
			<h2 class="hn"><span>Message</span></h2>
		</div>

		<div class="main-content main-frm">
			<div class="ct-box info-box">
				<p>No files found. 
<?php if ($forum_user['pan_downloads_upload'] == '1') : ?>
				<a href="<?php echo forum_link($forum_url['pan_downloads_new']) ?>">Upload a new file?<a/>
<?php endif; ?>
				</p>
			</div>
			
<?php if ($forum_user['g_id'] == FORUM_ADMIN) : ?>
		<form id="afocus" class="frm-form frm-ctrl-submit" method="post" accept-charset="utf-8" action="<?php echo forum_link($forum_url['pan_downloads_list']) ?>">
			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_downloads_list'])) ?>" />
			</div>
				<div class="frm-buttons">
					<span class="cancel">
						<input type="submit" name="scan" value="Scan the repository">
					</span>
				</div>
			</form>
<?php endif; ?>
		</div>
<?php
	}
	
	$tpl_temp = forum_trim(ob_get_contents());
	$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
	ob_end_clean();
	// END SUBST - <!-- forum_main -->
	
	require FORUM_ROOT.'footer.php';
}

($hook = get_hook('pan_downloads_mi_new_action_end')) ? eval($hook) : null;
