<?php 

if (!defined('PAN_DOWNLOADS_INSTALL')) die();

if (!$forum_db->table_exists('pan_downloads'))
{
	$schema = array(
		'FIELDS'		=> array(
			'id'			=> array(
				'datatype'		=> 'SERIAL',
				'allow_null'	=> false
			),
			'ext_id'		=> array(
				'datatype'		=> 'VARCHAR(100)',
				'allow_null'	=> false,
				'default'		=> '\'\''
			),
			'ext_ver'		=> array(
				'datatype'		=> 'VARCHAR(50)',
				'allow_null'	=> false,
				'default'		=> '\'\''
			),
			'ext_name'		=> array(
				'datatype'		=> 'VARCHAR(255)',
				'allow_null'	=> false,
				'default'		=> '\'\''
			),
			'ext_desc'		=> array(
				'datatype'		=> 'TEXT',
				'allow_null'	=> true
			),
			'content'		=> array(
				'datatype'		=> 'TEXT',
				'allow_null'	=> true
			),
			'author'		=> array(
				'datatype'		=> 'VARCHAR(100)',
				'allow_null'	=> false,
				'default'		=> '\'\''
			),
			'poster'		=> array(
				'datatype'		=> 'VARCHAR(100)',
				'allow_null'	=> false,
				'default'		=> '\'\''
			),
			'poster_id'		=> array(
				'datatype'		=> 'INT(10) UNSIGNED',
				'allow_null'	=> false,
				'default'		=> '1'
			),
			'min_ver'		=> array(
				'datatype'		=> 'VARCHAR(50)',
				'allow_null'	=> false,
				'default'		=> '\'\''
			),
			'max_ver'		=> array(
				'datatype'		=> 'VARCHAR(50)',
				'allow_null'	=> false,
				'default'		=> '\'\''
			),
			'db_type'		=> array(
				'datatype'		=> 'INT(1) UNSIGNED',
				'allow_null'	=> false,
				'default'		=> '0'
			),
			'posted'		=> array(
				'datatype'		=> 'INT(10) UNSIGNED',
				'allow_null'	=> false,
				'default'		=> '0'
			),
			'last_update'	=> array(
				'datatype'		=> 'INT(10) UNSIGNED',
				'allow_null'	=> false,
				'default'		=> '0'
			),
			'file_size'		=> array(
				'datatype'		=> 'INT(10) UNSIGNED',
				'allow_null'	=> false,
				'default'		=> '0'
			),
			'file_link'		=> array(
				'datatype'		=> 'VARCHAR(255)',
				'allow_null'	=> false,
				'default'		=> '\'\''
			),
			'source'		=> array(
				'datatype'		=> 'VARCHAR(255)',
				'allow_null'	=> false,
				'default'		=> '\'\''
			),
			'downloads'		=> array(
				'datatype'		=> 'INT(10) UNSIGNED',
				'allow_null'	=> false,
				'default'		=> '0'
			),
			'views'		=> array(
				'datatype'		=> 'INT(10) UNSIGNED',
				'allow_null'	=> false,
				'default'		=> '1'
			),
			'dependencies'		=> array(
				'datatype'		=> 'VARCHAR(255)',
				'allow_null'	=> false,
				'default'		=> '\'\''
			),
			'note'		=> array(
				'datatype'		=> 'VARCHAR(255)',
				'allow_null'	=> false,
				'default'		=> '\'\''
			),
		),
		'PRIMARY KEY'	=> array('id'),
		
	);

	$forum_db->create_table('pan_downloads', $schema);
}

forum_config_add('o_pan_downloads_path', '');


if (!$forum_db->field_exists('users', 'pan_downloads'))
	$forum_db->add_field('users', 'pan_downloads', 'TINYINT(1)', false, '1');

if (!$forum_db->field_exists('users', 'pan_downloads_upload'))
	$forum_db->add_field('users', 'pan_downloads_upload', 'TINYINT(1)', false, '0');

if (!$forum_db->field_exists('users', 'pan_downloads_edit'))
	$forum_db->add_field('users', 'pan_downloads_edit', 'TINYINT(1)', false, '0');

if (!$forum_db->field_exists('users', 'pan_downloads_delete'))
	$forum_db->add_field('users', 'pan_downloads_delete', 'TINYINT(1)', false, '0');


if (!$forum_db->field_exists('groups', 'g_pan_downloads'))
	$forum_db->add_field('groups', 'g_pan_downloads', 'TINYINT(1)', false, '1');

if (!$forum_db->field_exists('groups', 'g_pan_downloads_upload'))
	$forum_db->add_field('groups', 'g_pan_downloads_upload', 'TINYINT(1)', false, '0');

if (!$forum_db->field_exists('groups', 'g_pan_downloads_edit'))
	$forum_db->add_field('groups', 'g_pan_downloads_edit', 'TINYINT(1)', false, '0');

if (!$forum_db->field_exists('groups', 'g_pan_downloads_delete'))
	$forum_db->add_field('groups', 'g_pan_downloads_delete', 'TINYINT(1)', false, '0');

$query = array(
	'UPDATE'	=> 'users',
	'SET'		=> 'pan_downloads_upload=1, pan_downloads_edit=1, pan_downloads_delete=1',
	'WHERE'		=> 'group_id=1'
);
$forum_db->query_build($query) or error(__FILE__, __LINE__);





